Index: en-US/WS_Security.xml
===================================================================
--- en-US/WS_Security.xml	(revision 60201)
+++ en-US/WS_Security.xml	(revision 60202)
@@ -64,13 +64,84 @@
        Messages can also be signed. This allows you to ensure the authenticity of the message. If Alice wants to send a
        message to Bob, and Bob wants to be sure that it is from Alice, Alice can sign the message using her private key.
        Bob can then verify that the message is from Alice by using her public key.
-        </para>
+    </para>
     <mediaobject>
       <imageobject>
         <imagedata width="280" align="center" fileref="images/250px-Public_key_making.svg.png" format="PNG"/>
       </imageobject>
     </mediaobject>
-  </section>
+ </section>
+ <section id="ws-security-sslsettings">
+    <title>WS-Security Persistent Sessions</title>
+    <para>
+       Optimally, an encrypted session is persistent over multiple connections to the server from a single client.
+       Configure WS-Security for Windows or Linux using these procedures. When configured, the default length for a
+       persistent session is 5000 milliseconds. This is specified when the Enterprise Application Platform is started. 
+    </para>
+    <procedure>
+       <title>Configuring WS-Security Persistent Sessions on Linux</title>
+        <step>
+            <para>
+               Navigate to <filename class="directory">JBOSS_DIST/jboss-as/bin</filename>.
+            </para>
+         </step>
+         <step>
+            <para>
+               Using a text editor, open <filename>run.conf</filename>.
+            </para>
+         </step>
+         <step>
+            <para>
+               The Enterprise Application Platform options are set on this line:
+            </para>
+            <programlisting>JAVA_OPTS="-Xms1303m -Xmx1303m -XX:MaxPermSize=256m -Dorg.jboss.resolver.warning=true -Dsun.rmi.dgc.client.gcInterval=3600000 -Dsun.rmi.dgc.server.gcInterval=3600000 -Dsun.lang.ClassLoader.allowArraySyntax=true"
+            </programlisting>
+            <para>
+               Edit the line to include persistent connections of length <replaceable>SESSION_TIME</replaceable> in
+               milliseconds:
+            </para>
+            <programlisting>JAVA_OPTS="-Xms1303m -Xmx1303m -XX:MaxPermSize=256m -Dorg.jboss.resolver.warning=true -Dsun.rmi.dgc.client.gcInterval=3600000 -Dsun.rmi.dgc.server.gcInterval=3600000 -Dsun.lang.ClassLoader.allowArraySyntax=true -Dorg.jboss.ws.client.remoting.destruction.delay=<replaceable>SESSION_TIME</replaceable>"
+            </programlisting>
+         </step>
+         <step>
+            <para>
+               The new settings will take effect when the Enterprise Application Platform is shut down and restarted.
+            </para>
+         </step>
+    </procedure>
+    <procedure>
+         <title>Configuring WS-Security Persistent Sessions on Windows</title>
+         <step>
+            <para>
+               Navigate to <filename class="directory">JBOSS_DIST\jboss-as\bin</filename>.
+            </para>
+         </step>
+         <step>
+            <para>
+               Using a text editor, open <filename>run.conf.bat</filename>.
+            </para>
+         </step>
+         <step>
+            <para>
+               The Enterprise Application Platform options are set on this line:
+            </para>
+            <programlisting>set "JAVA_OPTS=-Xms1303m -Xmx1303m -XX:MaxPermSize=256m -Dorg.jboss.resolver.warning=true -Dsun.rmi.dgc.client.gcInterval=3600000 -Dsun.rmi.dgc.server.gcInterval=3600000 -Dsun.lang.ClassLoader.allowArraySyntax=true"
+            </programlisting>
+            <para>
+               Edit the line to include persistent connections of length <replaceable>SESSION_TIME</replaceable> in
+               milliseconds:
+            </para>
+            <programlisting>set "JAVA_OPTS=-Xms1303m -Xmx1303m -XX:MaxPermSize=256m -Dorg.jboss.resolver.warning=true -Dsun.rmi.dgc.client.gcInterval=3600000 -Dsun.rmi.dgc.server.gcInterval=3600000 -Dsun.lang.ClassLoader.allowArraySyntax=true -Dorg.jboss.ws.client.remoting.destruction.delay=<replaceable>SESSION_TIME</replaceable>"
+            </programlisting>
+         </step>
+         <step>
+            <para>
+               The new settings will take effect when the Enterprise Application Platform is shut down and restarted.
+            </para>
+         </step>
+      </procedure>
+
+ </section>
 <!--  <section>
     <title> Configuring the WSS4J Interceptors </title>
     <para>